import { __assign } from "tslib";
import * as React from 'react';
import PropTypes from 'prop-types';
import { Drawer } from 'tea-component';
var TeaDrawer = function (_a) {
    var size = _a.size, title = _a.title, style = _a.style, events = _a.events, visible = _a.visible, subtitle = _a.subtitle, showMask = _a.showMask, className = _a.className, placement = _a.placement, extraSlot = _a.extraSlot, footerSlot = _a.footerSlot, childrenSlot = _a.childrenSlot, disableCloseIcon = _a.disableCloseIcon, outerClickClosable = _a.outerClickClosable;
    var eventsList = {
        onClose: function () { return (events === null || events === void 0 ? void 0 : events.onClose) && events.onClose({}); },
        onExited: function () { return (events === null || events === void 0 ? void 0 : events.onExited) && events.onExited({}); },
    };
    return (React.createElement(Drawer, __assign({ size: size, title: title, style: style, visible: visible, extra: extraSlot, footer: footerSlot, subtitle: subtitle, showMask: showMask, className: className, placement: placement, disableCloseIcon: disableCloseIcon, outerClickClosable: outerClickClosable }, eventsList), childrenSlot));
};
TeaDrawer.propTypes = {
    style: PropTypes.object,
    visible: PropTypes.bool,
    title: PropTypes.string,
    showMask: PropTypes.bool,
    extraSlot: PropTypes.node,
    subtitle: PropTypes.string,
    footerSlot: PropTypes.node,
    className: PropTypes.string,
    childrenSlot: PropTypes.node,
    disableCloseIcon: PropTypes.bool,
    size: PropTypes.oneOf(['m', 'l']),
    outerClickClosable: PropTypes.bool,
    events: PropTypes.objectOf(PropTypes.func),
    placement: PropTypes.oneOf(['right', 'left']),
};
export default TeaDrawer;
export { TeaDrawer };
//# sourceMappingURL=index.js.map